<?php

define("UPLOAD_PATH", __DIR__ . "/upload/");
define("UPLOAD_LIMITS", [
    "size" => 500000,
    "formats" => ["png", "jpg", "gif"]
]);

function get_limitUploadMessage()
{
    $formats = join(" , ", UPLOAD_LIMITS['formats']);
    $size = round(UPLOAD_LIMITS['size'] / 1000);

    $message = " فرمت های مجاز {$formats} و حداکثر حجم فایل {$size} کیلوبایت";
    return $message;
}

function uploadPathType(string | null $type = null): string
{
    $type = strtoupper($type ?? "DISK");

    $result = "";

    switch ($type) {
        case "DISK":
            $result = realpath(UPLOAD_PATH);
            $result .= DIRECTORY_SEPARATOR;
            break;
        case "HTTP":
            $result = str_replace(__DIR__, "", UPLOAD_PATH);
            break;
    }

    return $result;
}

function insert_image($theFile, $new_name)
{
    $row = [];
    $mysqli = new mysqli("localhost", "root", "", "upload_images");
    if ($mysqli->connect_error) {
        die("MYSQL ISSUE : " . $mysqli->connect_error);
    }

    $mysqli->set_charset("utf8");
    $stmt = $mysqli->stmt_init();

    $upload_path = uploadPathType("disk") . "{$new_name}";

    $result_move_file = move_uploaded_file($theFile['tmp_name'], $upload_path);
    if (!$result_move_file) {
        die("خطایی حین انتقال فایل در دیسک به وجود آمده");
    }

    $upload_path = uploadPathType("http") . "{$new_name}";

    $finalData = [
       "original_name" => $theFile['name'],
       "new_name" => $new_name,
       "upload_path" => $upload_path
    ];


    $query = "INSERT INTO `images` (original_name , new_name , path) VALUES (? , ? , ?)";

    $inserted_id = 0;
    $stmt->prepare($query);
    $stmt->bind_param('sss', ...array_values($finalData));

    if ($stmt->execute()) {
        $inserted_id = $stmt->affected_rows ? $stmt->insert_id : 0;
    }

    $stmt->close();
    $mysqli->close();

    if($inserted_id){
        $finalData['id'] = $inserted_id;
        $row = $finalData;
    }

    return $row;
}

function validateFile(array $theFile): bool
{
    $result = false;

    if ($theFile['error']) {
        die("خطایی حین آپلود فایل پیش آمده ");
    }

    $filename = $theFile['name'];
    $filesize = $theFile['size'];

    $extension = @pathinfo($filename)['extension'] ?? "";

    if (UPLOAD_LIMITS['size'] < $filesize) return $result;
    else if (!in_array($extension, UPLOAD_LIMITS['formats'])) return $result;

    $result = true;

    return $result;
}

function generate_new_file_name(string $extension)
{
    $result = "file_" . time() . "." . "{$extension}";

    return $result;
}
